// DissolveFilter.h : Declaration of the CDissolveFilter

#pragma once
#include "resource.h"       // main symbols

#include "RWFilterDissolve_i.h"
#include <AutoCategories.h>


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif



// CDissolveFilter

class ATL_NO_VTABLE CDissolveFilter :
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CDissolveFilter, &CLSID_DissolveFilter>,
	public IDocumentOperation,
	public IAutoOperation
{
public:
	CDissolveFilter()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_DISSOLVEFILTER)
DECLARE_CLASSFACTORY_SINGLETON(CDissolveFilter)

BEGIN_CATEGORY_MAP(CMenuCommandsAutoOperation)
	IMPLEMENTED_CATEGORY(CATID_DocumentOperation)
	IMPLEMENTED_CATEGORY(CATID_AutoImageEffect)
END_CATEGORY_MAP()

BEGIN_COM_MAP(CDissolveFilter)
	COM_INTERFACE_ENTRY(IDocumentOperation)
	COM_INTERFACE_ENTRY(IAutoOperation)
END_COM_MAP()



	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

	// IDocumentOperation methods
public:
	STDMETHOD(NameGet)(IOperationManager* a_pManager, ILocalizedString** a_ppOperationName);
	STDMETHOD(ConfigCreate)(IOperationManager* a_pManager, IConfig** a_ppDefaultConfig);
	STDMETHOD(CanActivate)(IOperationManager* a_pManager, IDocument* a_pDocument, IConfig* a_pConfig, IOperationContext* a_pContext);
	STDMETHOD(Activate)(IOperationManager* a_pManager, IDocument* a_pDocument, IConfig* a_pConfig, IOperationContext* a_pContext, RWHWND a_hParent, LCID a_tLocaleID);

	// IAutoOperation methods
public:
	STDMETHOD(Name)(ILocalizedString** a_ppName);
	STDMETHOD(Description)(ILocalizedString** a_ppDesc);
	STDMETHOD(IconID)(GUID* a_pIconID);
	STDMETHOD(Accelerator)(TCmdAccel* a_pAccel, TCmdAccel* a_pAuxAccel);
	STDMETHOD(Configuration)(IConfig* a_pOperationCfg);

};

OBJECT_ENTRY_AUTO(__uuidof(DissolveFilter), CDissolveFilter)
