
#pragma once
// when making auto-operations, put them into one of the following categories
// their location in menu depends on the selected category

// operation is part of the application core
extern __declspec(selectany) CATID const CATID_TagCore = {0xafe7e26, 0x105f, 0x417f, {0x95, 0x44, 0xa9, 0x89, 0x3, 0x32, 0xf5, 0x6c}};

// operation displays user interface when run
extern __declspec(selectany) CATID const CATID_TagInteractive = {0x4f87d339, 0xe29c, 0x4687, {0x87, 0x84, 0xf5, 0xf8, 0xf6, 0xdb, 0xd4, 0x86}}; // {4F87D339-E29C-4687-8784-F5F8F6DBD486}

// operation uses other operations and cannot be used separately
extern __declspec(selectany) CATID const CATID_TagMetaOp = {0x5dce1970, 0xd9b9, 0x4bb0, {0xbe, 0x19, 0xa3, 0x0, 0xaa, 0x92, 0xa7, 0x54}}; // {5DCE1970-D9B9-4bb0-BE19-A300AA92A754}

// operation requires access to window states for proper function
extern __declspec(selectany) CATID const CATID_TagWindowState = {0x38804dc4, 0x74d0, 0x42d0, {0xbd, 0x83, 0xe2, 0x2f, 0x94, 0xe2, 0xe8, 0x4b}}; // {38804DC4-74D0-42d0-BD83-E22F94E2E84B}

// image filters recommended when creating layer style
extern __declspec(selectany) CATID const CATID_TagLayerStyle = {0xb5cc4ece, 0xaad4, 0x4335, {0xb6, 0xa, 0xe6, 0xe1, 0x25, 0x3c, 0x6d, 0x18}}; // {B5CC4ECE-AAD4-4335-B60A-E6E1253C6D18}

// image effects include filters like drop shadow, blur, crystalize, etc.
extern __declspec(selectany) CATID const CATID_TagImageEffect = {0xf23c6b90, 0x3452, 0x4f7c, {0xb7, 0xc0, 0x76, 0x47, 0xbc, 0x52, 0x7e, 0xb8}}; // {F23C6B90-3452-4f7c-B7C0-7647BC527EB8}

// image generators overwrite previous image (like fractal generators)
extern __declspec(selectany) CATID const CATID_TagImageGenerator = {0xf6cd5d16, 0x2f05, 0x45d6, {0xa4, 0xf2, 0x90, 0xbc, 0x31, 0x2b, 0xf6, 0xdd}}; // {F6CD5D16-2F05-45d6-A4F2-90BC312BF6DD}

// image adjustment include filters like levels, brightness, curves, etc.
extern __declspec(selectany) CATID const CATID_TagImageAdjust = {0x102ad2df, 0xaad0, 0x4173, {0x89, 0x95, 0x8a, 0xf2, 0xfb, 0xfd, 0x44, 0xff}}; // {102AD2DF-AAD0-4173-8995-8AF2FBFD44FF}

// layered image operations - any operation affecting multiple layers (like resample or canvas size)
extern __declspec(selectany) CATID const CATID_TagLayeredImage = {0x78218d44, 0x6891, 0x48e2, {0x91, 0x0f, 0xa9, 0x59, 0xd2, 0x6b, 0xf9, 0x5c}}; // {78218D44-6891-48E2-910F-A959D26BF95C}

// operation with image on a file level, like exporting or printing
extern __declspec(selectany) CATID const CATID_TagImageFile = {0xdaf2640d, 0x4b4c, 0x466a, {0xb5, 0xe1, 0xcc, 0xf5, 0xb5, 0x85, 0x13, 0xff}}; // {DAF2640D-4B4C-466A-B5E1-CCF5B58513FF}

// operation with a whole icon
extern __declspec(selectany) CATID const CATID_TagIcon = {0xef986f2c, 0x10cb, 0x433e, {0x9c, 0x22, 0xa5, 0x1a, 0x2a, 0x94, 0x32, 0xa}}; // {EF986F2C-10CB-433E-9C22-A51A2A94320A}

// operation with U3D file
extern __declspec(selectany) CATID const CATID_TagU3D = {0x8d243df7, 0x8e82, 0x4d7b, {0x9f, 0xe8, 0x17, 0x64, 0x79, 0x34, 0xa6, 0x22}}; // {8D243DF7-8E82-4D7B-9FE8-17647934A622}

