
#pragma once


struct CGammaTables
{
	WORD m_aGamma[256];
	BYTE m_aInvGamma[256+4];

	CGammaTables(float a_fGamma)
	{
		float const fMul = (1<<16)-1;
		for (ULONG i = 0; i < 256; ++i)
		{
			m_aGamma[i] = powf(i/255.0f, a_fGamma)*fMul+0.5f;
		}
		for (ULONG i = 0; i < 256; ++i)
		{
			m_aInvGamma[i] = powf(i/255.0f, 1.0f/a_fGamma)*255.0f+0.5f;
		}
		// it can happen due to rounding errors
		for (ULONG i = 0; i < 4; ++i)
			m_aInvGamma[i+256] = 255;
	}

	inline BYTE InvGamma(ULONG const a_n) const
	{
		BYTE const* const p = m_aInvGamma+(a_n>>8);
		return *p+(((a_n&0xff)*(p[1]-*p)+0x80)>>8);
	}
};
